# Publish

## Prerequisites
* __Application server along with an SSL certificate__ binaries included for linux and windows, we're running application on CentOS 8
* __Database server__  MySQL/MariaDB, we're using MariaDB v10.x

## Create configurations

### Create application config file

Use `configs/planeramera.json.example` to create `planeramera.json`.

Make the following adjustments:
* __oauth__: name your key (_consumer\_key_) and generate a secret (_consumer\_secret_)
* __https__: set _cert\_path_ and _key\_path_
* __canvas__: replace ... in _base\_url_, _auth\_url_ and  _token\_url_ with address to your canvas environment and in _redirect\_url_ with address to your application server

### Create LTI application definition

Use `configs/planeramera.xml.example` to create `configs/planeramera.xml`.

Make the following adjustments:
* Replace ... in URLs with address to your application server
* Set a unique _tool\_id_ (used to track app stats across accounts)

## Create database
Create database using `configs/database.sql`.

Use `configs/database_user.sql` (replacing _username_, _host_ and _password_ in script) to create a database user for the application.

Update `planeramera.json` _db.urn_ with _username_ and _password_ of created user and _address_ of database server.

## Create developer key in Canvas

Log in to Canvas using an account with administrator priviliges, navigate to _Admin_ --> your account --> _Developer keys_. Create new key by clicking  _+ Developer Key_ and choose type _API key_.
* __Key name__: name your key (users will be prompted to give key access to their account so choose a descriptive name)
* __Owner email__: your email address
* __Redirect URIs__: value from `planeramera.json` _canvas.redirect\_url_
* __Enforce Scopes__: activate and choose _Read only GET_. Scroll down to Calendar events, expand and choose _url:POST|/api/v1/calendar_events_

Update `planeramera.json` with _canvas.client\_id_ and _canvas.client\_secret_ from key created.

## Deploy application
Copy `planera-mera` (or `planera-mera.exe`), `planeramera.json` and `web/static` to application server and run `planera-mera` (or `planera-mera.exe`).

##  Register application in Canvas

Log in to Canvas using an account with administrator priviliges and navigate to _Admin_ --> your account --> _Settings_. On the _Apps_ tab, click _View App Configurations_ and register new app by clicking _+ App_

  * __Configuration Type__: _Paste XML_
  * __Name__: Study Planner
  * __Consumer key__: value from `planeramera.json` _oauth.consumer\_key_
  * __Shared secret__: value from `planeramera.json` _oauth.consumer\_secret_
  * __XML configuration__: paste `configs/lti.xml`.

An instructor can now add application to course navigation (under _Settings_ --> _Navigation_).
